Index: /branches/version-2_5-dev/data/class/helper/SC_Helper_DB.php
===================================================================
--- /branches/version-2_5-dev/data/class/helper/SC_Helper_DB.php	(revision 18790)
+++ /branches/version-2_5-dev/data/class/helper/SC_Helper_DB.php	(revision 18815)
@@ -185,4 +185,6 @@
      * 商品規格情報を取得する.
      *
+     * TODO SC_Product クラスへ移動
+     *
      * @param array $arrID 規格ID
      * @param boolean $includePrivateProducts 非公開商品を含むか
@@ -193,20 +195,28 @@
 
         if (strlen($classcategory_id1) == 0) {
-            $classcategory_id1 = '0';
+            $classcategory_id1 = null;
         }
         if (strlen($classcategory_id2) == 0) {
-            $classcategory_id2 = '0';
+            $classcategory_id2 = null;
         }
 
         // 商品規格取得
-        $objQuery =& SC_Query::getSingletonInstance();
-        $col = 'product_id, deliv_fee, name, product_code, main_list_image, main_image, price01, price02, point_rate, product_class_id, classcategory_id1, classcategory_id2, class_id1, class_id2, stock, stock_unlimited, sale_limit';
-        $table = 'vw_product_class AS prdcls';
-        $where = 'product_id = ? AND classcategory_id1 = ? AND classcategory_id2 = ?';
-        if (!$includePrivateProducts) {
-             $where .= ' AND status = 1';
-        }
-        $arrRet = $objQuery->select($col, $table, $where, array($product_id, $classcategory_id1, $classcategory_id2));
-        return $arrRet[0];
+        $objProduct = new SC_Product();
+        $detail = $objProduct->getDetail($product_id);
+        $productsClass = $objProduct->getProductsClassFullByProductId($product_id);
+        foreach ($productsClass as $val) {
+
+            if ($val['classcategory_id1'] == $classcategory_id1
+                && $val['classcategory_id2'] == $classcategory_id2) {
+
+                $detail = array_merge($val, $detail);
+                if (!$includePrivateProducts) {
+                    if ($detail['status'] == 1) {
+                        return $detail;
+                    }
+                }
+                return $detail;
+            }
+        }
     }
 
@@ -912,23 +922,10 @@
         }
 
-        //各カテゴリ内の商品数を数えて格納
-        $sql = <<< __EOS__
-            INSERT INTO dtb_category_count(category_id, product_count, create_date)
-            SELECT T1.category_id, count(T2.category_id), now()
-            FROM dtb_category AS T1
-                LEFT JOIN dtb_product_categories AS T2
-                    ON T1.category_id = T2.category_id
-                LEFT JOIN vw_products_allclass_detail AS alldtl
-                    ON T2.product_id = alldtl.product_id
-            WHERE $sql_where
-            GROUP BY T1.category_id, T2.category_id
-__EOS__;
-
-        $objQuery->query($sql);
-
         //子カテゴリ内の商品数を集計する
 
         // カテゴリ情報を取得
         $arrCat = $objQuery->select('category_id', 'dtb_category');
+
+        $objProduct = new SC_Product();
 
         foreach ($arrCat as $row) {
@@ -940,10 +937,12 @@
             list($tmp_where, $tmp_arrval) = $this->sfGetCatWhere($category_id);
             if ($tmp_where != "") {
-                $sql_where_product_ids = "alldtl.product_id IN (SELECT product_id FROM dtb_product_categories WHERE " . $tmp_where . ")";
-                $arrval = array_merge((array)$arrval, (array)$tmp_arrval);
+                $sql_where_product_ids = "product_id IN (SELECT product_id FROM dtb_product_categories WHERE " . $tmp_where . ")";
+                $arrval = array_merge((array)$arrval, (array)$tmp_arrval, (array)$tmp_arrval);
             } else {
                 $sql_where_product_ids = '0<>0'; // 一致させない
             }
-
+            $where = "($sql_where) AND ($sql_where_product_ids)";
+
+            $from = $objProduct->alldtlSQL($sql_where_product_ids);
             $sql = <<< __EOS__
                 INSERT INTO dtb_category_total_count (category_id, product_count, create_date)
@@ -952,6 +951,6 @@
                     ,count(*)
                     ,now()
-                FROM vw_products_allclass_detail AS alldtl
-                WHERE ($sql_where) AND ($sql_where_product_ids)
+                FROM $from
+               WHERE $where
 __EOS__;
 
@@ -986,5 +985,5 @@
         $objQuery =& SC_Query::getSingletonInstance();
         $col = $pid_name . "," . $id_name;
-         $arrData = $objQuery->select($col, $table);
+        $arrData = $objQuery->select($col, $table);
 
         $arrPID = array();
@@ -1910,5 +1909,5 @@
 
         $objQuery =& SC_Query::getSingletonInstance();
-        $where = 'product_id = ? AND (classcategory_id1 <> 0 OR classcategory_id2 <> 0)';
+        $where = 'product_id = ? AND class_combination_id IS NOT NULL';
         $count = $objQuery->count('dtb_products_class', $where, array($product_id));
 
Index: /branches/version-2_5-dev/data/class/helper/SC_Helper_CSV.php
===================================================================
--- /branches/version-2_5-dev/data/class/helper/SC_Helper_CSV.php	(revision 18791)
+++ /branches/version-2_5-dev/data/class/helper/SC_Helper_CSV.php	(revision 18815)
@@ -132,4 +132,9 @@
         $objQuery->setOrder($order);
 
+        /*
+         * FIXME
+         * パフォーマンスが出ないため,
+         * SC_Product::getProductsClassByProductIds() を使用した実装に変更
+         */
         $dataRows = $objQuery->select(
              SC_Utils_Ex::sfGetCommaList($arrOutputCols, true, array('category_id'))
Index: /branches/version-2_5-dev/data/class/SC_Product.php
===================================================================
--- /branches/version-2_5-dev/data/class/SC_Product.php	(revision 18701)
+++ /branches/version-2_5-dev/data/class/SC_Product.php	(revision 18815)
@@ -42,51 +42,121 @@
     var $classCat2_find;
     var $classCats1;
-    
-    function SC_Product($arrProductId = null) {
-        $objDb = new SC_Helper_DB_Ex();
-        
-        // 規格名一覧
-        $this->arrClassName = $objDb->sfGetIDValueList("dtb_class", "class_id", "name");
-        // 規格分類名一覧
-        $this->arrClassCatName = $objDb->sfGetIDValueList("dtb_classcategory", "classcategory_id", "name");
-        $this->arrClassCatName[''] = '選択してください';
-        
-        if (!is_null($arrProductId)) {
-            $this->setProductId($arrProductId);
-        }
-    }
-
-    function setProductId($arrProductId) {
-        
-        // 商品規格情報の取得
-        $rows = $this->lfGetProductsClass($arrProductId);
-        
+
+    /**
+     * SC_Queryインスタンスに設定された検索条件をもとに商品IDの配列を取得する.
+     *
+     * 検索条件は, SC_Query::getWhere() 関数で設定しておく必要があります.
+     *
+     * @param SC_Query $objQuery SC_Query インスタンス
+     * @param array $arrVal 検索パラメータの配列
+     * @return array 商品IDの配列
+     */
+    function findProductIds(&$objQuery, $arrVal = array()) {
+        $table = <<< __EOS__
+                 dtb_products AS alldtl
+            JOIN dtb_product_categories AS T2
+              ON alldtl.product_id = T2.product_id
+            JOIN dtb_category
+              ON T2.category_id = dtb_category.category_id
+__EOS__;
+        // SC_Query::getCol() ではパフォーマンスが出ない
+        $results = $objQuery->select('alldtl.product_id', $table, "", $arrVal,
+                                     MDB2_FETCHMODE_ORDERED);
+        foreach ($results as $val) {
+            $resultValues[] = $val[0];
+        }
+        return array_unique($resultValues);
+    }
+
+    /**
+     * SC_Queryインスタンスに設定された検索条件をもとに商品一覧の配列を取得する.
+     *
+     * 主に SC_Product::findProductIds() で取得した商品IDを検索条件にし,
+     * SC_Query::setOrder() や SC_Query::setLimitOffset() を設定して, 商品一覧
+     * の配列を取得する.
+     *
+     * @param SC_Query $objQuery SC_Query インスタンス
+     * @param array $arrVal 検索パラメータ(ソート条件)の配列
+     * @return array 商品一覧の配列
+     */
+    function lists(&$objQuery, $arrVal = array()) {
+        $col = <<< __EOS__
+             product_id
+            ,product_code_min
+            ,product_code_max
+            ,name
+            ,comment1
+            ,comment2
+            ,comment3
+            ,main_list_comment
+            ,main_image
+            ,main_list_image
+            ,price01_min
+            ,price01_max
+            ,price02_min
+            ,price02_max
+            ,stock_min
+            ,stock_max
+            ,stock_unlimited_min
+            ,stock_unlimited_max
+            ,deliv_date_id
+            ,status
+            ,del_flg
+            ,update_date
+__EOS__;
+        return $objQuery->select($col, $this->alldtlSQL($objQuery->where),
+                                 "", $arrVal);
+    }
+
+    /**
+     * 商品詳細を取得する.
+     *
+     * @param integer $productId 商品ID
+     * @return array 商品詳細情報の配列
+     */
+    function getDetail($productId) {
+        $objQuery =& SC_Query::getSingletonInstance();
+        $result = $objQuery->select("*", $this->alldtlSQL("product_id = ?"),
+                                    "product_id = ?",
+                                    array($productId, $productId));
+        return $result[0];
+    }
+
+    /**
+     * 商品IDに紐づく商品規格を自分自身に設定する.
+     *
+     * 引数の商品IDの配列に紐づく商品規格を取得し, 自分自身のフィールドに
+     * 設定する.
+     *
+     * @param array $arrProductId 商品ID の配列
+     * @return void
+     */
+    function setProductsClassByProductIds($arrProductId) {
+
+        foreach ($arrProductId as $productId) {
+            $rows[$productId] = $this->getProductsClassFullByProductId($productId);
+        }
+
         $arrProductsClass = array();
-        foreach ($rows as $row) {
-            $productId = $row['product_id'];
-            $arrProductsClass[$productId][] = $row;
-        }
-        unset($rows);
-        
-        foreach ($arrProductsClass as $productId => $arrProductClass) {
+        foreach ($rows as $productId => $arrProductClass) {
             $classCats1 = array();
             $classCats1[''] = '選択してください';
-            
+
             // 規格1クラス名
             $this->className1[$productId] =
-                isset($this->arrClassName[$arrProductClass[0]['class_id1']])
-                ? $this->arrClassName[$arrProductClass[0]['class_id1']]
+                isset($arrProductClass[0]['class_name1'])
+                ? $arrProductClass[0]['class_name1']
                 : '';
 
             // 規格2クラス名
             $this->className2[$productId] =
-                isset($this->arrClassName[$arrProductClass[0]['class_id2']])
-                ? $this->arrClassName[$arrProductClass[0]['class_id2']]
+                isset($arrProductClass[0]['class_name2'])
+                ? $arrProductClass[0]['class_name2']
                 : '';
-            
+
             // 規格1が設定されている
-            $this->classCat1_find[$productId] = ($arrProductClass[0]['classcategory_id1'] != '0');
+            $this->classCat1_find[$productId] = (!SC_Utils_Ex::isBlank($arrProductClass[0]['classcategory_id1']));
             // 規格2が設定されている
-            $this->classCat2_find[$productId] = ($arrProductClass[0]['classcategory_id2'] != '0');
+            $this->classCat2_find[$productId] = (!SC_Utils_Ex::isBlank($arrProductClass[0]['classcategory_id2']));
 
             $this->stock_find[$productId] = false;
@@ -97,13 +167,11 @@
                 $productsClass2 = $productsClass['classcategory_id2'];
                 $classCategories[$productsClass1]['']['name'] = '選択してください';
-
                 // 在庫
                 $stock_find_class = ($productsClass['stock_unlimited'] || $productsClass['stock'] > 0);
-                
-                $classCategories[$productsClass1][$productsClass2]['name'] = $this->arrClassCatName[$productsClass2]
-                    . ($stock_find_class ? '' : ' (品切れ中)');
-                
+
+                $classCategories[$productsClass1][$productsClass2]['name'] = $productsClass['name2'] . ($stock_find_class ? '' : ' (品切れ中)');
+
                 $classCategories[$productsClass1][$productsClass2]['stock_find'] = $stock_find_class;
-                
+
                 if ($stock_find_class) {
                     $this->stock_find[$productId] = true;
@@ -111,8 +179,8 @@
 
                 if (!in_array($classcat_id1, $classCats1)) {
-                    $classCats1[$productsClass1] = $this->arrClassCatName[$productsClass1]
+                    $classCats1[$productsClass1] = $productsClass['name1']
                         . ($productsClass2 == 0 && !$stock_find_class ? ' (品切れ中)' : '');
                 }
-                
+
                 // 価格
                 $classCategories[$productsClass1][$productsClass2]['price01']
@@ -120,21 +188,21 @@
                     ? number_format(SC_Helper_DB_Ex::sfPreTax($productsClass['price01']))
                     : '';
-                
+
                 $classCategories[$productsClass1][$productsClass2]['price02']
                     = strlen($productsClass['price02'])
                     ? number_format(SC_Helper_DB_Ex::sfPreTax($productsClass['price02']))
                     : '';
-                
+
                 // ポイント
                 // XXX sfPrePoint() の第4パラメータは、処理にバグがあるため現状省略している。(http://xoops.ec-cube.net/modules/newbb/viewtopic.php?topic_id=3540&forum=1&post_id=13853#forumpost13853)
                 $classCategories[$productsClass1][$productsClass2]['point']
                     = SC_Utils_Ex::sfPrePoint($productsClass['price02'], $productsClass['point_rate']);
-                
+
                 // 商品コード
                 $classCategories[$productsClass1][$productsClass2]['product_code'] = $productsClass['product_code'];
             }
-            
+
             $this->classCategories[$productId] = $classCategories;
-            
+
             // 規格1
             $this->classCats1[$productId] = $classCats1;
@@ -142,21 +210,244 @@
     }
 
-    /* 商品規格情報の取得 */
-    function lfGetProductsClass($arrProductId) {
-        $arrProductId = (Array) $arrProductId;
-        
-        if (empty($arrProductId)) {
+    /**
+     * 複数の商品IDに紐づいた, 商品規格を取得する.
+     *
+     * @param array $productIds 商品IDの配列
+     * @return array 商品規格の配列
+     */
+    function getProductsClassByProductIds($productIds = array()) {
+        if (empty($productIds)) {
             return array();
         }
-        
-        // 商品規格取得
-        $objQuery = new SC_Query();
-        $col = 'product_id, classcategory_id1, classcategory_id2, class_id1, class_id2, stock, stock_unlimited, price01, price02, point_rate, product_code';
-        $table = 'vw_product_class AS prdcls';
-        $where = 'product_id IN (' . implode(', ', array_pad(array(), count($arrProductId), '?')) . ')';
-        $objQuery->setOrder("product_id, rank1 DESC, rank2 DESC");
-        $arrRet = $objQuery->select($col, $table, $where, $arrProductId);
-        
-        return $arrRet;
+        $objQuery =& SC_Query::getSingletonInstance();
+        $objQuery->setWhere('product_id IN (' . implode(', ', array_pad(array(), count($productIds), '?')) . ')');
+        $objQuery->setOrder("T2.level DESC");
+        // 末端の規格を取得
+        $col = <<< __EOS__
+            T1.product_id,
+            T1.stock,
+            T1.stock_unlimited,
+            T1.price01,
+            T1.price02,
+            T1.point_rate,
+            T1.product_code,
+            T1.product_class_id,
+            T1.del_flg,
+            T2.class_combination_id,
+            T2.parent_class_combination_id,
+            T2.classcategory_id,
+            T2.level,
+            T3.name,
+            T4.name AS class_name,
+            T4.class_id
+__EOS__;
+        $table = <<< __EOS__
+                      dtb_products_class T1
+            LEFT JOIN dtb_class_combination T2
+                   ON T1.class_combination_id = T2.class_combination_id
+            LEFT JOIN dtb_classcategory T3
+                   ON T2.classcategory_id = T3.classcategory_id
+            LEFT JOIN dtb_class T4
+                   ON T3.class_id = T4.class_id
+__EOS__;
+        $arrRet = $objQuery->select($col, $table, "", $productIds);
+        $levels = array();
+        $parents = array();
+
+        foreach ($arrRet as $rows) {
+            $levels[] = $rows['level'];
+            $parents[] = $rows['parent_class_combination_id'];
+        }
+        $level = max($levels);
+        $parentsClass = array();
+        // 階層分の親を取得
+        for ($i = 0; $i < $level -1; $i++) {
+            $objQuery =& SC_Query::getSingletonInstance();
+            $objQuery->setWhere('T1.class_combination_id IN (' . implode(', ', array_pad(array(), count($parents), '?')) . ')');
+
+            $col = <<< __EOS__
+                T1.class_combination_id,
+                T1.classcategory_id,
+                T1.parent_class_combination_id,
+                T1.level,
+                T2.name,
+                T3.name AS class_name,
+                T3.class_id
+__EOS__;
+            $table = <<< __EOS__
+                          dtb_class_combination T1
+                LEFT JOIN dtb_classcategory T2
+                       ON T1.classcategory_id = T2.classcategory_id
+                LEFT JOIN dtb_class T3
+                       ON T2.class_id = T3.class_id
+__EOS__;
+
+            $arrParents = $objQuery->select($col, $table, "", $parents);
+
+            unset($parents);
+            foreach ($arrParents as $rows) {
+                $parents[] = $rows['parent_class_combination_id'];
+
+                foreach ($arrRet as $child) {
+                    if ($child['parent_class_combination_id']
+                        == $rows['class_combination_id']) {
+                        $rows['product_id'] = $child['product_id'];
+                    }
+                }
+                $tmpParents[] = $rows;
+            }
+            $parentsClass = array_merge($parentsClass, $tmpParents);
+        }
+
+        // 末端から枝を作成
+        $tmpClass = array_merge($arrRet, $parentsClass);
+
+        foreach ($tmpClass as $val) {
+            $val['class_id' . $val['level']] = $val['class_id'];
+            $val['class_name' . $val['level']] = $val['class_name'];
+            $val['name' . $val['level']] = $val['name'];
+            $val['classcategory_id' . $val['level']] = $val['classcategory_id'];
+            $arrProductsClass[] = $val;
+        }
+
+        return $arrProductsClass;
+    }
+
+    /**
+     * 商品IDに紐づいた, 商品規格を階層ごとに取得する.
+     *
+     * @param array $productId 商品IDの配列
+     * @return array 階層ごとの商品規格の配列
+     */
+    function getProductsClassLevelByProductId($productId) {
+        $results = $this->getProductsClassByProductIds(array($productId));
+        foreach ($results as $row) {
+            $productsClassLevel["level" . $row['level']][] = $row;
+        }
+        return $productsClassLevel;
+    }
+
+    /**
+     * 商品IDに紐づいた, 商品規格をすべての組み合わせごとに取得する.
+     *
+     * @param array $productId 商品IDの配列
+     * @return array すべての組み合わせの商品規格の配列
+     */
+    function getProductsClassFullByProductId($productId) {
+        $results = $this->getProductsClassLevelByProductId($productId);
+        $productsClass = array();
+        foreach ($results["level1"] as $level1) {
+            foreach ($results["level2"] as $level2) {
+                if ($level2['parent_class_combination_id'] == $level1['class_combination_id']) {
+                    $level1 = array_merge($level1, $level2);
+                }
+            }
+            $productsClass[] = $level1;
+        }
+        return $productsClass;
+    }
+
+    /**
+     * 商品詳細の SQL を取得する.
+     *
+     * @param string $where 商品詳細の WHERE 句
+     * @return string 商品詳細の SQL
+     */
+    function alldtlSQL($where = "") {
+        $whereCause = "";
+        if (!SC_Utils_Ex::isBlank($where)) {
+            $whereCause = " WHERE " . $where;
+        }
+
+        $sql = <<< __EOS__
+            (
+             SELECT dtb_products.product_id,
+                    dtb_products.name,
+                    dtb_products.maker_id,
+                    dtb_products.rank,
+                    dtb_products.status,
+                    dtb_products.comment1,
+                    dtb_products.comment2,
+                    dtb_products.comment3,
+                    dtb_products.comment4,
+                    dtb_products.comment5,
+                    dtb_products.comment6,
+                    dtb_products.note,
+                    dtb_products.file1,
+                    dtb_products.file2,
+                    dtb_products.file3,
+                    dtb_products.file4,
+                    dtb_products.file5,
+                    dtb_products.file6,
+                    dtb_products.main_list_comment,
+                    dtb_products.main_list_image,
+                    dtb_products.main_comment,
+                    dtb_products.main_image,
+                    dtb_products.main_large_image,
+                    dtb_products.sub_title1,
+                    dtb_products.sub_comment1,
+                    dtb_products.sub_image1,
+                    dtb_products.sub_large_image1,
+                    dtb_products.sub_title2,
+                    dtb_products.sub_comment2,
+                    dtb_products.sub_image2,
+                    dtb_products.sub_large_image2,
+                    dtb_products.sub_title3,
+                    dtb_products.sub_comment3,
+                    dtb_products.sub_image3,
+                    dtb_products.sub_large_image3,
+                    dtb_products.sub_title4,
+                    dtb_products.sub_comment4,
+                    dtb_products.sub_image4,
+                    dtb_products.sub_large_image4,
+                    dtb_products.sub_title5,
+                    dtb_products.sub_comment5,
+                    dtb_products.sub_image5,
+                    dtb_products.sub_large_image5,
+                    dtb_products.sub_title6,
+                    dtb_products.sub_comment6,
+                    dtb_products.sub_image6,
+                    dtb_products.sub_large_image6,
+                    dtb_products.del_flg,
+                    dtb_products.creator_id,
+                    dtb_products.create_date,
+                    dtb_products.update_date,
+                    dtb_products.deliv_date_id,
+                    dtb_products.down,
+                    dtb_products.down_filename,
+                    dtb_products.down_realfilename,
+                    T4.product_code_min,
+                    T4.product_code_max,
+                    T4.price01_min,
+                    T4.price01_max,
+                    T4.price02_min,
+                    T4.price02_max,
+                    T4.stock_min,
+                    T4.stock_max,
+                    T4.stock_unlimited_min,
+                    T4.stock_unlimited_max,
+                    T4.class_count
+               FROM dtb_products
+               JOIN (
+                       SELECT product_id,
+                              MIN(product_code) AS product_code_min,
+                              MAX(product_code) AS product_code_max,
+                              MIN(price01) AS price01_min,
+                              MAX(price01) AS price01_max,
+                              MIN(price02) AS price02_min,
+                              MAX(price02) AS price02_max,
+                              MIN(stock) AS stock_min,
+                              MAX(stock) AS stock_max,
+                              MIN(stock_unlimited) AS stock_unlimited_min,
+                              MAX(stock_unlimited) AS stock_unlimited_max,
+                              COUNT(*) as class_count
+                         FROM dtb_products_class
+                       $whereCause
+                     GROUP BY product_id
+                     ) AS T4
+                 ON dtb_products.product_id = T4.product_id
+        ) AS alldtl
+__EOS__;
+        return $sql;
     }
 }
Index: /branches/version-2_5-dev/data/class/pages/products/LC_Page_Products_Detail.php
===================================================================
--- /branches/version-2_5-dev/data/class/pages/products/LC_Page_Products_Detail.php	(revision 18770)
+++ /branches/version-2_5-dev/data/class/pages/products/LC_Page_Products_Detail.php	(revision 18815)
@@ -151,6 +151,7 @@
         $this->lfMakeSelect($product_id);
 
-        require_once CLASS_PATH . 'SC_Product.php';
-        $objProduct = new SC_Product($product_id);
+        $objProduct = new SC_Product();
+        $objProduct->setProductsClassByProductIds(array($product_id));
+
         // 規格1クラス名
         $this->tpl_class_name1 = $objProduct->className1[$product_id];
@@ -227,7 +228,6 @@
         $this->arrErr = $arrErr;
 
-        // DBから商品情報を取得する。
-        $arrRet = $objQuery->select("*, (SELECT count(*) FROM dtb_customer_favorite_products WHERE product_id = alldtl.product_id AND customer_id = ?) AS favorite_count", "vw_products_allclass_detail AS alldtl", "product_id = ?", array($objCustomer->getValue('customer_id'), $product_id));
-        $this->arrProduct = $arrRet[0];
+        // 商品詳細を取得
+        $this->arrProduct = $objProduct->getDetail($product_id);
 
         // サブタイトルを取得
@@ -421,8 +421,7 @@
         }
 
-        $objQuery = new SC_Query();
-        // DBから商品情報を取得する。
-        $arrRet = $objQuery->select("*", "vw_products_allclass_detail AS alldtl", "product_id = ?", array($product_id));
-        $this->arrProduct = $arrRet[0];
+        // 商品詳細を取得
+        $objProduct = new SC_Product();
+        $this->arrProduct = $objProduct->getDetail($product_id);
 
         // サブタイトルを取得
@@ -531,4 +530,9 @@
         // 規格分類名一覧
         $arrClassCatName = $objDb->sfGetIDValueList("dtb_classcategory", "classcategory_id", "name");
+        /*
+         * FIXME
+         * パフォーマンスが出ないため,
+         * SC_Product::getProductsClassByProductIds() を使用した実装に変更
+         */
         // 商品規格情報の取得
         $arrProductsClass = $this->lfGetProductsClass($product_id);
@@ -617,4 +621,5 @@
         $max = count($arrRet);
         $no = 0;
+        // FIXME SC_Product クラスを使用した実装
         $from = "vw_products_allclass AS T1 "
                 . " JOIN ("
@@ -626,5 +631,5 @@
         for($i = 0; $i < $max; $i++) {
             $where = "del_flg = 0 AND T3.product_id = ? AND status = 1";
-            $arrProductInfo = $objQuery->select("DISTINCT main_list_image, price02_min, price02_max, price01_min, price01_max, name, point_rate, T3.product_rank", $from, $where, array($arrRet[$i]['recommend_product_id']));
+            $arrProductInfo = $objQuery->select("DISTINCT main_list_image, price02_min, price02_max, price01_min, price01_max, name, T3.product_rank", $from, $where, array($arrRet[$i]['recommend_product_id']));
 
             if(count($arrProductInfo) > 0) {
Index: /branches/version-2_5-dev/data/class/pages/products/LC_Page_Products_List.php
===================================================================
--- /branches/version-2_5-dev/data/class/pages/products/LC_Page_Products_List.php	(revision 18792)
+++ /branches/version-2_5-dev/data/class/pages/products/LC_Page_Products_List.php	(revision 18815)
@@ -310,5 +310,4 @@
     function lfDispProductsList() {
 
-        $objQuery = new SC_Query();
         $objDb = new SC_Helper_DB_Ex();
         $arrval = array();
@@ -324,4 +323,5 @@
         // 商品検索条件の作成（未削除、表示）
         $where = "del_flg = 0 AND status = 1 ";
+        $where1 = "alldtl.del_flg = 0 AND alldtl.status = 1 ";
         
         // 在庫無し商品の非表示
@@ -332,4 +332,5 @@
         if (strlen($where_category) >= 1) {
             $where.= " AND $where_category";
+            $where1 .= " AND T2.$where_category";
             $arrval = array_merge($arrval, $arrval_category);
         }
@@ -346,4 +347,5 @@
             if ( strlen($val) > 0 ) {
                 $where .= " AND ( name ILIKE ? OR comment3 ILIKE ?) ";
+                $where1 .= " AND ( alldtl.name ILIKE ? OR alldtl.comment3 ILIKE ?) ";
                 $arrval[] = "%$val%";
                 $arrval[] = "%$val%";
@@ -354,9 +356,14 @@
         if ($this->arrSearchData['maker_id']) {
             $where .= " AND maker_id = ? ";
+            $where1 .= " AND alldtl.maker_id = ? ";
             $arrval[] = $this->arrSearchData['maker_id'];
         }
-        
-        // 対象商品IDの抽出
-        $arrProduct_id = array_unique($objQuery->getCol('vw_products_allclass AS allcls', 'product_id', $where, $arrval));
+
+        // 一覧表示する商品IDを取得
+        $objQuery =& SC_Query::getSingletonInstance();
+        $objQuery->setWhere($where1);
+        $objProduct = new SC_Product();
+        $arrProduct_id = $objProduct->findProductIds($objQuery, $arrval);
+
         // 行数の取得
         $linemax = count($arrProduct_id);
@@ -373,35 +380,4 @@
         $startno = $this->objNavi->start_row;                 // 開始行
         
-        // ▼商品詳細取得
-        $col = <<< __EOS__
-             product_id
-            ,product_code_min
-            ,product_code_max
-            ,name
-            ,comment1
-            ,comment2
-            ,comment3
-            ,main_list_comment
-            ,main_image
-            ,main_list_image
-            ,price01_min
-            ,price01_max
-            ,price02_min
-            ,price02_max
-            ,stock_min
-            ,stock_max
-            ,stock_unlimited_min
-            ,stock_unlimited_max
-            ,point_rate
-            ,sale_limit
-            ,deliv_date_id
-            ,deliv_fee
-            ,status
-            ,product_flag
-            ,del_flg
-__EOS__;
-        
-        $from = "vw_products_allclass_detail AS alldtl";
-        
         // WHERE 句
         $where = '0=0';
@@ -412,5 +388,5 @@
             $where .= ' AND 0<>0';
         }
-        
+
         // 表示順序
         switch ($this->orderby) {
@@ -462,11 +438,13 @@
         
         // 取得範囲の指定(開始行番号、行数のセット)
-        $objQuery->setLimitOffset($this->disp_number, $startno);
-        // 表示順序
-        $objQuery->setOrder($order);
-        
+        $objQuery =& SC_Query::getSingletonInstance();
+        $objQuery->setLimitOffset($this->disp_number, $startno)
+                 ->setOrder($order)
+                 ->setWhere($where);
+
         // 検索結果の取得
-        $this->arrProducts = $objQuery->select($col, $from, $where, $arrval_order);
-        // ▲商品詳細取得
+        $objProduct = new SC_Product();
+        $this->arrProducts = $objProduct->lists($objQuery, $arrval_order);
+
         
         $arrProductId = array();
@@ -476,6 +454,6 @@
         }
         
-        require_once CLASS_PATH . 'SC_Product.php';
-        $objProduct = new SC_Product($arrProductId);
+        // 規格を設定
+        $objProduct->setProductsClassByProductIds($arrProductId);
         
         // 規格1クラス名
Index: /branches/version-2_5-dev/data/class/pages/rss/LC_Page_Rss_Products.php
===================================================================
--- /branches/version-2_5-dev/data/class/pages/rss/LC_Page_Rss_Products.php	(revision 18701)
+++ /branches/version-2_5-dev/data/class/pages/rss/LC_Page_Rss_Products.php	(revision 18815)
@@ -194,4 +194,5 @@
      */
     function lfGetProductsAllclass($objQuery){
+        // FIXME SC_Product クラスを使用した実装
         $sql = "";
         $sql .= "SELECT
Index: /branches/version-2_5-dev/data/class/pages/mypage/LC_Page_Mypage_Favorite.php
===================================================================
--- /branches/version-2_5-dev/data/class/pages/mypage/LC_Page_Mypage_Favorite.php	(revision 18770)
+++ /branches/version-2_5-dev/data/class/pages/mypage/LC_Page_Mypage_Favorite.php	(revision 18815)
@@ -94,4 +94,5 @@
         }
 
+        // FIXME SC_Product クラスを使用した実装
         $col = "alldtl.*";
         $from = "dtb_customer_favorite_products AS dcfp LEFT JOIN vw_products_allclass_detail AS alldtl USING(product_id)";
